##// END OF EJS Templates
correcting wrong logic while selecting architecture
Unknown -
r301:3721bfc9be50
parent child
Show More
@@ -1,766 +1,768
1 1 #!/bin/sh
2 2
3 3 ########################################################################
4 4 # rpi23-gen-image.sh 2015-2017
5 5 #
6 6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
7 7 #
8 8 # This program is free software; you can redistribute it and/or
9 9 # modify it under the terms of the GNU General Public License
10 10 # as published by the Free Software Foundation; either version 2
11 11 # of the License, or (at your option) any later version.
12 12 #
13 13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 14 #
15 15 # Big thanks for patches and enhancements by 20+ github contributors!
16 16 ########################################################################
17 17
18 18 # Are we running as root?
19 19 if [ "$(id -u)" -ne "0" ] ; then
20 20 echo "error: this script must be executed with root privileges!"
21 21 exit 1
22 22 fi
23 23
24 24 # Check if ./functions.sh script exists
25 25 if [ ! -r "./functions.sh" ] ; then
26 26 echo "error: './functions.sh' required script not found!"
27 27 exit 1
28 28 fi
29 29
30 30 # Load utility functions
31 31 . ./functions.sh
32 32
33 33 # Load parameters from configuration template file
34 34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 35 use_template
36 36 fi
37 37
38 38 # Introduce settings
39 39 set -e
40 40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 41 set -x
42 42
43 43 # Raspberry Pi model configuration
44 44 RPI_MODEL=${RPI_MODEL:=2}
45 45
46 46 # Debian release
47 47 RELEASE=${RELEASE:=jessie}
48 48
49 49 #Kernel Branch
50 50 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
51 51
52 52 # URLs
53 53 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
54 54 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
55 55 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
56 56 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
57 57 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
58 58 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
59 59
60 60 # Build directories
61 61 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
62 62 BUILDDIR="${BASEDIR}/build"
63 63
64 64 # Prepare date string for default image file name
65 65 DATE="$(date +%Y-%m-%d)"
66 66 if [ -z "$KERNEL_BRANCH" ] ; then
67 67 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
68 68 else
69 69 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
70 70 fi
71 71
72 72 # Chroot directories
73 73 R="${BUILDDIR}/chroot"
74 74 ETC_DIR="${R}/etc"
75 75 LIB_DIR="${R}/lib"
76 76 BOOT_DIR="${R}/boot/firmware"
77 77 KERNEL_DIR="${R}/usr/src/linux"
78 78 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
79 79
80 80 # Firmware directory: Blank if download from github
81 81 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
82 82
83 83 # General settings
84 84 SET_ARCH=${SET_ARCH}
85 85 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
86 86 PASSWORD=${PASSWORD:=raspberry}
87 87 USER_PASSWORD=${USER_PASSWORD:=raspberry}
88 88 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
89 89 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
90 90 EXPANDROOT=${EXPANDROOT:=true}
91 91
92 92 # Keyboard settings
93 93 XKB_MODEL=${XKB_MODEL:=""}
94 94 XKB_LAYOUT=${XKB_LAYOUT:=""}
95 95 XKB_VARIANT=${XKB_VARIANT:=""}
96 96 XKB_OPTIONS=${XKB_OPTIONS:=""}
97 97
98 98 # Network settings (DHCP)
99 99 ENABLE_DHCP=${ENABLE_DHCP:=true}
100 100
101 101 # Network settings (static)
102 102 NET_ADDRESS=${NET_ADDRESS:=""}
103 103 NET_GATEWAY=${NET_GATEWAY:=""}
104 104 NET_DNS_1=${NET_DNS_1:=""}
105 105 NET_DNS_2=${NET_DNS_2:=""}
106 106 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
107 107 NET_NTP_1=${NET_NTP_1:=""}
108 108 NET_NTP_2=${NET_NTP_2:=""}
109 109
110 110 # APT settings
111 111 APT_PROXY=${APT_PROXY:=""}
112 112 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
113 113
114 114 # Feature settings
115 115 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
116 116 ENABLE_I2C=${ENABLE_I2C:=false}
117 117 ENABLE_SPI=${ENABLE_SPI:=false}
118 118 ENABLE_IPV6=${ENABLE_IPV6:=true}
119 119 ENABLE_SSHD=${ENABLE_SSHD:=true}
120 120 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
121 121 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
122 122 ENABLE_SOUND=${ENABLE_SOUND:=true}
123 123 ENABLE_DBUS=${ENABLE_DBUS:=true}
124 124 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
125 125 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
126 126 ENABLE_XORG=${ENABLE_XORG:=false}
127 127 ENABLE_WM=${ENABLE_WM:=""}
128 128 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
129 129 ENABLE_USER=${ENABLE_USER:=true}
130 130 USER_NAME=${USER_NAME:="pi"}
131 131 ENABLE_ROOT=${ENABLE_ROOT:=false}
132 132 ENABLE_QEMU=${ENABLE_QEMU:=false}
133 133
134 134 # SSH settings
135 135 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
136 136 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
137 137 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
138 138 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
139 139 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
140 140
141 141 # Advanced settings
142 142 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
143 143 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
144 144 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
145 145 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
146 146 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
147 147 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
148 148 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
149 149 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
150 150 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
151 151 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
152 152 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
153 153 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
154 154
155 155 # Kernel compilation settings
156 156 BUILD_KERNEL=${BUILD_KERNEL:=false}
157 157 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
158 158 KERNEL_THREADS=${KERNEL_THREADS:=1}
159 159 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
160 160 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
161 161 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
162 162 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
163 163 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
164 164
165 165 # Kernel compilation from source directory settings
166 166 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
167 167 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
168 168 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
169 169 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
170 170
171 171 # Reduce disk usage settings
172 172 REDUCE_APT=${REDUCE_APT:=true}
173 173 REDUCE_DOC=${REDUCE_DOC:=true}
174 174 REDUCE_MAN=${REDUCE_MAN:=true}
175 175 REDUCE_VIM=${REDUCE_VIM:=false}
176 176 REDUCE_BASH=${REDUCE_BASH:=false}
177 177 REDUCE_HWDB=${REDUCE_HWDB:=true}
178 178 REDUCE_SSHD=${REDUCE_SSHD:=true}
179 179 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
180 180
181 181 # Encrypted filesystem settings
182 182 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
183 183 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
184 184 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
185 185 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
186 186 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
187 187
188 188 # Chroot scripts directory
189 189 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
190 190
191 191 # Packages required in the chroot build environment
192 192 APT_INCLUDES=${APT_INCLUDES:=""}
193 193 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
194 194
195 195 # Packages required for bootstrapping
196 196 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
197 197 MISSING_PACKAGES=""
198 198
199 199 # Packages installed for c/c++ build environment in chroot (keep empty)
200 200 COMPILER_PACKAGES=""
201 201
202 202 set +x
203 203
204 204 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
205 205 if [ -n "$SET_ARCH" ] ; then
206 206 echo "Setting Architecture specific settings"
207 207 ##################################
208 208 # 64 bit config
209 209 ##################################
210 if [ "$SET_ARCH" = 64 ] && ([ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]); then
210 if [ "$SET_ARCH" = 64 ] ; then
211 211 echo "64 bit mode selected - Setting up enviroment"
212 212 # 64 bit depended settings
213 213 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
214 214 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
215 215 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
216 216 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
217 217 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
218 218 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
219 219
220 # RPI 3 serie specific settings
221 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
222 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
220 if ([ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]) ; then
221 # RPI 3 serie specific settings
222 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
223 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
223 224
224 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
225 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
226 else
227 echo "error: Only Raspberry PI 3 and 3B+ support 64bit"
228 exit 1
225 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
226 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
227 else
228 echo "error: At the moment Raspberry PI 3 and 3B+ are the only Models which support 64bit"
229 exit 1
230 fi
229 231 fi
230 232
231 233 ##################################
232 234 # 32 bit config
233 235 ##################################
234 236 if [ "$SET_ARCH" = 32 ] ; then
235 237 echo "32 bit mode selected - Setting up enviroment"
236 238 #General 32bit configuration
237 239 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
238 240 KERNEL_ARCH=${KERNEL_ARCH:=arm}
239 241 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
240 242
241 243 #Raspberry setting grouped by board compability
242 244 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
243 245 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
244 246 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
245 247 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
246 248 RELEASE_ARCH=${RELEASE_ARCH:=armel}
247 249 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
248 250 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
249 251 fi
250 252 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
251 253 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
252 254 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
253 255 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
254 256 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
255 257 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
256 258 fi
257 259
258 260 #Device specific configuration
259 261 case "$RPI_MODEL" in
260 262 0)
261 263 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb} ;;
262 264 1)
263 265 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb} ;;
264 266 1P)
265 267 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb} ;;
266 268 2)
267 269 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
268 270 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
269 271 #Precompiled Kernel rpi2
270 272 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
271 273 ;;
272 274 3)
273 275 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
274 276 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
275 277 ;;
276 278 3P)
277 279 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
278 280 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
279 281 ;;
280 282 *)
281 283 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
282 284 exit 1
283 285 ;;
284 286 esac
285 287 #end 32 bit
286 288 fi
287 289 #SET_ARCH not set
288 290 else
289 291 echo "error: Please set '32' or '64' as value for SET_ARCH"
290 292 exit 1
291 293 fi
292 294
293 295 # Check if the internal wireless interface is supported by the RPi model
294 296 if [ "$ENABLE_WIRELESS" = true ] && ([ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ]) ; then
295 297 echo "error: The selected Raspberry Pi model has no internal wireless interface"
296 298 exit 1
297 299 else
298 300 echo "Raspberry Pi model"
299 301 fi
300 302
301 303 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
302 304 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
303 305 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
304 306 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
305 307 exit 1
306 308 fi
307 309 fi
308 310
309 311 # Add libncurses5 to enable kernel menuconfig
310 312 if [ "$KERNEL_MENUCONFIG" = true ] ; then
311 313 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
312 314 fi
313 315
314 316 # Add ccache compiler cache for (faster) kernel cross (re)compilation
315 317 if [ "$KERNEL_CCACHE" = true ] ; then
316 318 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
317 319 fi
318 320
319 321 # Add cryptsetup package to enable filesystem encryption
320 322 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
321 323 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
322 324 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
323 325
324 326 if [ -z "$CRYPTFS_PASSWORD" ] ; then
325 327 echo "error: no password defined (CRYPTFS_PASSWORD)!"
326 328 exit 1
327 329 fi
328 330 ENABLE_INITRAMFS=true
329 331 fi
330 332
331 333 # Add initramfs generation tools
332 334 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
333 335 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
334 336 fi
335 337
336 338 # Add device-tree-compiler required for building the U-Boot bootloader
337 339 if [ "$ENABLE_UBOOT" = true ] ; then
338 340 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
339 341 fi
340 342
341 343 # Check if root SSH (v2) public key file exists
342 344 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
343 345 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
344 346 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
345 347 exit 1
346 348 fi
347 349 fi
348 350
349 351 # Check if $USER_NAME SSH (v2) public key file exists
350 352 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
351 353 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
352 354 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
353 355 exit 1
354 356 fi
355 357 fi
356 358
357 359 # Check if all required packages are installed on the build system
358 360 for package in $REQUIRED_PACKAGES ; do
359 361 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
360 362 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
361 363 fi
362 364 done
363 365
364 366 # If there are missing packages ask confirmation for install, or exit
365 367 if [ -n "$MISSING_PACKAGES" ] ; then
366 368 echo "the following packages needed by this script are not installed:"
367 369 echo "$MISSING_PACKAGES"
368 370
369 371 echo -n "\ndo you want to install the missing packages right now? [y/n] "
370 372 read confirm
371 373 [ "$confirm" != "y" ] && exit 1
372 374
373 375 # Make sure all missing required packages are installed
374 376 apt-get -qq -y install ${MISSING_PACKAGES}
375 377 fi
376 378
377 379 # Check if ./bootstrap.d directory exists
378 380 if [ ! -d "./bootstrap.d/" ] ; then
379 381 echo "error: './bootstrap.d' required directory not found!"
380 382 exit 1
381 383 fi
382 384
383 385 # Check if ./files directory exists
384 386 if [ ! -d "./files/" ] ; then
385 387 echo "error: './files' required directory not found!"
386 388 exit 1
387 389 fi
388 390
389 391 # Check if specified KERNELSRC_DIR directory exists
390 392 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
391 393 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
392 394 exit 1
393 395 fi
394 396
395 397 # Check if specified UBOOTSRC_DIR directory exists
396 398 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
397 399 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
398 400 exit 1
399 401 fi
400 402
401 403 # Check if specified FBTURBOSRC_DIR directory exists
402 404 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
403 405 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
404 406 exit 1
405 407 fi
406 408
407 409 # Check if specified CHROOT_SCRIPTS directory exists
408 410 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
409 411 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
410 412 exit 1
411 413 fi
412 414
413 415 # Check if specified device mapping already exists (will be used by cryptsetup)
414 416 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
415 417 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
416 418 exit 1
417 419 fi
418 420
419 421 # Don't clobber an old build
420 422 if [ -e "$BUILDDIR" ] ; then
421 423 echo "error: directory ${BUILDDIR} already exists, not proceeding"
422 424 exit 1
423 425 fi
424 426
425 427 # Setup chroot directory
426 428 mkdir -p "${R}"
427 429
428 430 # Check if build directory has enough of free disk space >512MB
429 431 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
430 432 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
431 433 exit 1
432 434 fi
433 435
434 436 set -x
435 437
436 438 # Call "cleanup" function on various signals and errors
437 439 trap cleanup 0 1 2 3 6
438 440
439 441 # Add required packages for the minbase installation
440 442 if [ "$ENABLE_MINBASE" = true ] ; then
441 443 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
442 444 fi
443 445
444 446 # Add required locales packages
445 447 if [ "$DEFLOCAL" != "en_US.UTF-8" ] || ([ -n XKB_MODEL ] || [ -n XKB_LAYOUT ] || [ -n XKB_VARIANT ] || [ -n XKB_OPTIONS ]); then
446 448 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
447 449 fi
448 450
449 451 # Add parted package, required to get partprobe utility
450 452 if [ "$EXPANDROOT" = true ] ; then
451 453 APT_INCLUDES="${APT_INCLUDES},parted"
452 454 fi
453 455
454 456 # Add dbus package, recommended if using systemd
455 457 if [ "$ENABLE_DBUS" = true ] ; then
456 458 APT_INCLUDES="${APT_INCLUDES},dbus"
457 459 fi
458 460
459 461 # Add iptables IPv4/IPv6 package
460 462 if [ "$ENABLE_IPTABLES" = true ] ; then
461 463 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
462 464 fi
463 465
464 466 # Add openssh server package
465 467 if [ "$ENABLE_SSHD" = true ] ; then
466 468 APT_INCLUDES="${APT_INCLUDES},openssh-server"
467 469 fi
468 470
469 471 # Add alsa-utils package
470 472 if [ "$ENABLE_SOUND" = true ] ; then
471 473 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
472 474 fi
473 475
474 476 # Add rng-tools package
475 477 if [ "$ENABLE_HWRANDOM" = true ] ; then
476 478 APT_INCLUDES="${APT_INCLUDES},rng-tools"
477 479 fi
478 480
479 481 # Add fbturbo video driver
480 482 if [ "$ENABLE_FBTURBO" = true ] ; then
481 483 # Enable xorg package dependencies
482 484 ENABLE_XORG=true
483 485 fi
484 486
485 487 # Add user defined window manager package
486 488 if [ -n "$ENABLE_WM" ] ; then
487 489 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
488 490
489 491 # Enable xorg package dependencies
490 492 ENABLE_XORG=true
491 493 fi
492 494
493 495 # Add xorg package
494 496 if [ "$ENABLE_XORG" = true ] ; then
495 497 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
496 498 fi
497 499
498 500 # Replace selected packages with smaller clones
499 501 if [ "$ENABLE_REDUCE" = true ] ; then
500 502 # Add levee package instead of vim-tiny
501 503 if [ "$REDUCE_VIM" = true ] ; then
502 504 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
503 505 fi
504 506
505 507 # Add dropbear package instead of openssh-server
506 508 if [ "$REDUCE_SSHD" = true ] ; then
507 509 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
508 510 fi
509 511 fi
510 512
511 513 if [ "$RELEASE" != "jessie" ] ; then
512 514 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
513 515 fi
514 516
515 517 # Configure kernel sources if no KERNELSRC_DIR
516 518 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
517 519 KERNELSRC_CONFIG=true
518 520 fi
519 521
520 522 # Configure reduced kernel
521 523 if [ "$KERNEL_REDUCE" = true ] ; then
522 524 KERNELSRC_CONFIG=false
523 525 fi
524 526
525 527 # Execute bootstrap scripts
526 528 for SCRIPT in bootstrap.d/*.sh; do
527 529 head -n 3 "$SCRIPT"
528 530 . "$SCRIPT"
529 531 done
530 532
531 533 ## Execute custom bootstrap scripts
532 534 if [ -d "custom.d" ] ; then
533 535 for SCRIPT in custom.d/*.sh; do
534 536 . "$SCRIPT"
535 537 done
536 538 fi
537 539
538 540 # Execute custom scripts inside the chroot
539 541 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
540 542 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
541 543 chroot_exec /bin/bash -x <<'EOF'
542 544 for SCRIPT in /chroot_scripts/* ; do
543 545 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
544 546 $SCRIPT
545 547 fi
546 548 done
547 549 EOF
548 550 rm -rf "${R}/chroot_scripts"
549 551 fi
550 552
551 553 # Remove c/c++ build environment from the chroot
552 554 chroot_remove_cc
553 555
554 556 # Remove apt-utils
555 557 if [ "$RELEASE" = "jessie" ] ; then
556 558 chroot_exec apt-get purge -qq -y --force-yes apt-utils
557 559 fi
558 560
559 561 # Generate required machine-id
560 562 MACHINE_ID=$(dbus-uuidgen)
561 563 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
562 564 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
563 565
564 566 # APT Cleanup
565 567 chroot_exec apt-get -y clean
566 568 chroot_exec apt-get -y autoclean
567 569 chroot_exec apt-get -y autoremove
568 570
569 571 # Unmount mounted filesystems
570 572 umount -l "${R}/proc"
571 573 umount -l "${R}/sys"
572 574
573 575 # Clean up directories
574 576 rm -rf "${R}/run/*"
575 577 rm -rf "${R}/tmp/*"
576 578
577 579 # Clean up files
578 580 rm -f "${ETC_DIR}/ssh/ssh_host_*"
579 581 rm -f "${ETC_DIR}/dropbear/dropbear_*"
580 582 rm -f "${ETC_DIR}/apt/sources.list.save"
581 583 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
582 584 rm -f "${ETC_DIR}/*-"
583 585 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
584 586 rm -f "${ETC_DIR}/resolv.conf"
585 587 rm -f "${R}/root/.bash_history"
586 588 rm -f "${R}/var/lib/urandom/random-seed"
587 589 rm -f "${R}/initrd.img"
588 590 rm -f "${R}/vmlinuz"
589 591 rm -f "${R}${QEMU_BINARY}"
590 592
591 593 if [ "$ENABLE_QEMU" = true ] ; then
592 594 # Configure qemu compatible kernel
593 595 DTB_FILE=vexpress-v2p-ca15_a7.dtb
594 596 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
595 597 KERNEL_DEFCONFIG="vexpress_defconfig"
596 598 if [ "$KERNEL_MENUCONFIG" = false ] ; then
597 599 KERNEL_OLDDEFCONFIG=true
598 600 fi
599 601
600 602 # Setup QEMU directory
601 603 mkdir "${BASEDIR}/qemu"
602 604
603 605 # Copy kernel image to QEMU directory
604 606 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
605 607
606 608 # Copy kernel config to QEMU directory
607 609 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
608 610
609 611 # Copy kernel dtbs to QEMU directory
610 612 for dtb in "${BOOT_DIR}/"*.dtb ; do
611 613 if [ -f "${dtb}" ] ; then
612 614 install_readonly "${dtb}" "${BASEDIR}/qemu/"
613 615 fi
614 616 done
615 617
616 618 # Copy kernel overlays to QEMU directory
617 619 if [ -d "${BOOT_DIR}/overlays" ] ; then
618 620 # Setup overlays dtbs directory
619 621 mkdir "${BASEDIR}/qemu/overlays"
620 622
621 623 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
622 624 if [ -f "${dtb}" ] ; then
623 625 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
624 626 fi
625 627 done
626 628 fi
627 629
628 630 # Copy u-boot files to QEMU directory
629 631 if [ "$ENABLE_UBOOT" = true ] ; then
630 632 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
631 633 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
632 634 fi
633 635 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
634 636 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
635 637 fi
636 638 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
637 639 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
638 640 fi
639 641 fi
640 642
641 643 # Copy initramfs to QEMU directory
642 644 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
643 645 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
644 646 fi
645 647 fi
646 648
647 649 # Calculate size of the chroot directory in KB
648 650 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
649 651
650 652 # Calculate the amount of needed 512 Byte sectors
651 653 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
652 654 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
653 655 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
654 656
655 657 # The root partition is EXT4
656 658 # This means more space than the actual used space of the chroot is used.
657 659 # As overhead for journaling and reserved blocks 35% are added.
658 660 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
659 661
660 662 # Calculate required image size in 512 Byte sectors
661 663 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
662 664
663 665 # Prepare image file
664 666 if [ "$ENABLE_SPLITFS" = true ] ; then
665 667 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
666 668 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
667 669 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
668 670 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
669 671
670 672 # Write firmware/boot partition tables
671 673 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
672 674 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
673 675 EOM
674 676
675 677 # Write root partition table
676 678 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
677 679 ${TABLE_SECTORS},${ROOT_SECTORS},83
678 680 EOM
679 681
680 682 # Setup temporary loop devices
681 683 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
682 684 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
683 685 else # ENABLE_SPLITFS=false
684 686 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
685 687 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
686 688
687 689 # Write partition table
688 690 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
689 691 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
690 692 ${ROOT_OFFSET},${ROOT_SECTORS},83
691 693 EOM
692 694
693 695 # Setup temporary loop devices
694 696 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
695 697 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
696 698 fi
697 699
698 700 if [ "$ENABLE_CRYPTFS" = true ] ; then
699 701 # Create dummy ext4 fs
700 702 mkfs.ext4 "$ROOT_LOOP"
701 703
702 704 # Setup password keyfile
703 705 touch .password
704 706 chmod 600 .password
705 707 echo -n ${CRYPTFS_PASSWORD} > .password
706 708
707 709 # Initialize encrypted partition
708 710 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
709 711
710 712 # Open encrypted partition and setup mapping
711 713 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
712 714
713 715 # Secure delete password keyfile
714 716 shred -zu .password
715 717
716 718 # Update temporary loop device
717 719 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
718 720
719 721 # Wipe encrypted partition (encryption cipher is used for randomness)
720 722 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
721 723 fi
722 724
723 725 # Build filesystems
724 726 mkfs.vfat "$FRMW_LOOP"
725 727 mkfs.ext4 "$ROOT_LOOP"
726 728
727 729 # Mount the temporary loop devices
728 730 mkdir -p "$BUILDDIR/mount"
729 731 mount "$ROOT_LOOP" "$BUILDDIR/mount"
730 732
731 733 mkdir -p "$BUILDDIR/mount/boot/firmware"
732 734 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
733 735
734 736 # Copy all files from the chroot to the loop device mount point directory
735 737 rsync -a "${R}/" "$BUILDDIR/mount/"
736 738
737 739 # Unmount all temporary loop devices and mount points
738 740 cleanup
739 741
740 742 # Create block map file(s) of image(s)
741 743 if [ "$ENABLE_SPLITFS" = true ] ; then
742 744 # Create block map files for "bmaptool"
743 745 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
744 746 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
745 747
746 748 # Image was successfully created
747 749 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
748 750 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
749 751 else
750 752 # Create block map file for "bmaptool"
751 753 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
752 754
753 755 # Image was successfully created
754 756 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
755 757
756 758 # Create qemu qcow2 image
757 759 if [ "$ENABLE_QEMU" = true ] ; then
758 760 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
759 761 QEMU_SIZE=16G
760 762
761 763 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
762 764 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
763 765
764 766 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
765 767 fi
766 768 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant